--- old/usr/src/uts/common/fs/zfs/dsl_dataset.c	2013-05-16 14:21:05.766942112 -0600
+++ new/usr/src/uts/common/fs/zfs/dsl_dataset.c	2013-05-16 14:21:05.776646224 -0600
@@ -356,8 +356,10 @@
 
 	/* Make sure dsobj has the correct object type. */
 	dmu_object_info_from_db(dbuf, &doi);
-	if (doi.doi_type != DMU_OT_DSL_DATASET)
+	if (doi.doi_type != DMU_OT_DSL_DATASET) {
+		dmu_buf_rele(dbuf, tag);
 		return (SET_ERROR(EINVAL));
+	}
 
 	ds = dmu_buf_get_user(dbuf);
 	if (ds == NULL) {
